/************************************************************* 
* ElectronicBattery.pde - simple electronic circuit          *
* class for battery                                          *
* written in Processing                                      *
* http://www.penguintutor.com/software.php                   *
* This is part of circuit1.pde software                      *
*************************************************************/
// Copyright 2010 Stewart Watkiss
/*  
    The circuit1.pde softweare is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This code is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this software.  If not, see <http://www.gnu.org/licenses/>.
*/

// this version of the class only works with circuit 1 (changes for future circuits)
class ElectronicBattery {
	// position of positive connection (default top of battery)
	// initial setting -1 do not display
	int positionX = -1;
	int positionY = -1;
	
	PFont fontSymbolText;
	
	public ElectronicBattery() {
		fontSymbolText = loadFont("Dialog.plain-10.vlw");
	}
	
	public ElectronicBattery (int x, int y) {
		positionX = x;
		positionY = y;
		fontSymbolText = loadFont("Dialog.plain-10.vlw");
	}
	
	
	void setPosition (int x, int y) {
		positionX = x;
		positionY = y;
	}
	
	int getStartX () {
		return positionX;
	}
	
	int getStartY () {
		return positionY;
	}
	
	// end position is y + 35
	int getEndX () {
		return positionX;
	}
	
	int getEndY () {
		return positionY + 35;
	}
	
	
	void display () {
		// if positioned off screen then we don't display - object may have been created for future use
		if (positionX < 0 || positionY < 0 ) {return;}
		line (positionX - 20, positionY, positionX + 20, positionY);
		line (positionX - 10, positionY + 5, positionX + 10, positionY + 5);
		line (positionX, positionY + 10, positionX, positionY + 15);
		line (positionX, positionY + 20, positionX, positionY + 25);
		line (positionX - 20, positionY + 30, positionX + 20, positionY + 30);
		line (positionX - 10, positionY + 35, positionX + 10, positionY + 35);
		// add + sign
		fill (#000000);
		textFont (fontSymbolText);
		text ("+", positionX + 10, positionY -3 );
				
	}
		
	
	
}
