/************************************************************* 
* ElectronicSwitch.pde - simple electronic circuit           *
* class for switch                                           *
* written in Processing                                      *
* http://www.penguintutor.com/software.php                   *
* This is part of circuit1.pde software                      *
*************************************************************/
// Copyright 2010 Stewart Watkiss
/*  
    The circuit1.pde softweare is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This code is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this software.  If not, see <http://www.gnu.org/licenses/>.
*/

class ElectronicSwitch {
	// position of first connection (default left of switch)
	// initial setting -1 do not display
	int positionX = -1;
	int positionY = -1;
	
	// Use int as it means we can add multi-way in future 
	// May need to do differently for mutlipole 
	int status = 1;	// 0 = open, 1 = closed
	
	public ElectronicSwitch() {
	}

	// Constructor with initial position values
	public ElectronicSwitch(int x, int y) {
		positionX = x;
		positionY = y;
	}
	
	void setPosition (int x, int y) {
		positionX = x;
		positionY = y;

	}
	
	
	int getStartX () {
		return positionX;
	}
	
	int getStartY () {
		return positionY;
	}
	
	// end position is x + 40
	int getEndX () {
		return positionX + 40;
	}
	
	int getEndY () {
		return positionY;
	}
	
	
	void setStatus (int newStatus) {
		status = newStatus;
	}
	
	int getStatus () {
		return status;
	}
	
	// If any on we turn off, if off we turn on 1
	void toggleStatus () {
		if (status == 0) {status = 1;}
		else {status = 0;}
	}
	
	void display() {
		// if positioned off screen then we don't display - object may have been created for future use
		if (positionX < 0 || positionY < 0 ) {return;}
		fill (colorBackground);
		ellipse (positionX, positionY, 5, 5);
		ellipse (positionX + 40, positionY, 5, 5); 
		if (status == 1) { line (positionX, positionY-2, positionX + 40, positionY - 2); } 
		else {line (positionX, positionY-2, positionX + 40, positionY - 20);}
	}
}
