/************************************************************* 
* ElectronicWire.pde - simple electronic circuit             *
* class for wire                                             *
* written in Processing                                      *
* http://www.penguintutor.com/software.php                   *
* This is part of circuit1.pde software                      *
*************************************************************/
// Copyright 2010 Stewart Watkiss
/*  
    The circuit1.pde softweare is free software: you can redistribute it and/or
    modify it under the terms of the GNU General Public License as published
    by the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This code is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this software.  If not, see <http://www.gnu.org/licenses/>.
*/


// point where 2 or more wires connect
// effectively a connection point / terminal etc.
class ElectronicWire {
	// position of first connection 
	int startX = -1;
	int startY = -1;
	// position of last connection
	int endX = -1;
	int endY = -1;
	
	// positionX is where a label will go if selected
	// by leaving at -1 we don't show any label
	int positionX = -1;
	int positionY = -1;
	
	// number of connections (if < 2 don't display circle - if >= 2 do)
	int connections = 0;
	
	public ElectronicWire() {
	}

	// Constructor with initial position values 
	// note this does not set position which is of text label
	// insetad we set start and end points - if label required we set seperately
	public ElectronicWire(int newstartX, int newstartY, int newendX, int newendY) {
		startX = newstartX;
		startY = newstartY;
		endX = newendX;
		endY = newendY;
	}
	
	// sets position of label
	void setPosition (int x, int y) {
		positionX = x;
		positionY = y;

	}
	
	void setStart (int newstartX, int newstartY) {
		startX = newstartX;
		startY = newstartY;
	}
	
	void setEnd (int newendX, int newendY) {
		endX = newendX;
		endY = newendY;
	}
	
	
	void display() {
		// Position will be used for label in future
		//if (positionX < 0 || positionY < 0 ) {return;}
		// draw line from start position to end position
		line (startX, startY, endX, endY);
	}
}
